$(function () {
    let $username = $('#username'),
        $profileInfo = $('#profileInfo').first(),
        $login = $('#login'),
        $password = $('#password'),
        $error = $('.auth_error'),
        $signInButton = $('#signin_b');


    // Показ профиля при нажатии
    $('#settingsButton').click(() =>
        $.getJSON(g_URLdir + 'window/settings')
            .done(data => { wnd.open(data); onSettingsPopup() }));

    
    let isUsernameLayer = node => (node == $username[0]) || $.contains($profileInfo[0], node);
    
    $(document).click(e => isUsernameLayer(e.target) || $profileInfo.slideUp(200));
    $username.click(_ => $profileInfo.slideToggle(200));


    function closeSession() {
        $.post(g_URLdir + 'handler/Session/closeSession')
            .done(_ => { $('.popup_overlay').show(); $login.focus() }) }

    function setSessionTimer(time) {
        let updateTime = () =>
            $.postJSON(g_URLdir + 'handler/Session/getSessionTime', {})
                .done(wait => (wait <= 10) ? closeSession() : setSessionTimer(wait - 10));

        setTimeout(updateTime, 1000 * time);
    }

    setSessionTimer(1);


    // todo: animation
    Auth.onAllow = () => $signInButton.turnOn();
    Auth.onDeprecate = () => $signInButton.turnOff();


    function tryToAuthorize() {
        const login = $login.val();
        const pass = $password.val();

        // check fields are empty
        if (login.length == 0 || pass.length == 0) {
            login.length ? $password.focus() : $login.focus();
            return;
        }

        // send ajax request
        Auth.signIn(login, pass)
            .fail(_ => $error.show())
            .done(_ => {
                // global var at base.twig
                User.login == login
                    ? setSessionTimer(15)
                    : window.location.replace(g_URLdir);

                $('.popup_overlay').hide();
                $error.hide();
                $login.val('');
                $password.val('');
            });
    }

    $login.add($password).keypress(function (event) {
        if (event.keyCode == 13)
            tryToAuthorize();
        else $error.fadeOut(600);
    });

    $signInButton.click(tryToAuthorize);

});
